oracle.mc = rep(0, reps) 
MNlda.mc = rep(0, reps) 
propval.mc = rep(0, reps) 
witten.mc = rep(0, reps)
msda.mc = rep(0, reps)
sda.mc = rep(NA, reps)
set.seed(seed)
library(compiler)
enableJIT(3)

for(kk in 1:reps){
	
# ------  create data 
	if(!trans){
		dat1 = CREATE_DAT_COV1(r=r, p=p, C=3, rho.U = 0.5, rho.V = 0.5, 
			N=N, N_validate=N_validate, N_test=N_test)
	} else {
		dat1 = CREATE_DAT_COV1_TRANS(r=r, p=p, C=3, rho.U = 0.5, rho.V = 0.5, 
			N=N, N_validate=N_validate, N_test=N_test)
	}


# ------ rename created data
	X = dat1$X
	class = dat1$class
	X_val = dat1$X_val
	X_test = dat1$X_test
	U = dat1$U
	V = dat1$V
	Uinv = solve(U)
	Vinv = solve(V)

# ------ population mean
	Mu_Array = dat1$Mu_Array
	class_test = dat1$class_test
	class_val = dat1$class_val
	nc = count(class)[,2]
	pihat = nc/N
	vecX_test = apply(X_test, 3, as.vector)
	vecX_val = apply(X_val, 3, as.vector)

	
#  -------  Witten 
	Witten.val = matrix(0, nrow=length(lambda1.Witten), ncol=C-1)
	Witten.test = matrix(0, nrow=length(lambda1.Witten), ncol=C-1)
	
	for(j in 1:length(lambda1.Witten)){
		for(k in 1:(C-1)){
			Witten.val[j,k]= sum(PenalizedLDA(x=t(apply(X, 3, as.vector)),y=class,lambda=lambda1.Witten[j],K=k, xte=t(vecX_val))$ypred[,k] != class_val)/length(class_val)
			Witten.test[j,k]= sum(PenalizedLDA(x=t(apply(X, 3, as.vector)),y=class,lambda=lambda1.Witten[j],K=k, xte=t(vecX_test))$ypred[,k] != class_test)/length(class_test)
		}	
	}

	ind2 = min(which(Witten.val == min(Witten.val), arr.ind=TRUE)[,2])
  	ind1 = max(which(Witten.val[,ind2] == min(Witten.val[,ind2])))
	witten.mc[kk] = Witten.test[ind1, ind2]


# -------- MSDA
	out = msda(t(apply(X, 3, as.vector)), factor(class), nlambda=100)
	preds = (colSums(predict(out, newx=t(vecX_val)) != class_val)/length(class_val))
	ind = max(which(preds == min(preds)))
	msda.mc[kk] = sum(predict(out, newx=t(vecX_test))[,ind] != class_test)/length(class_test)


# -------- SDA 
	vecX = t(apply(X, 3, as.vector))
	Y = matrix(0, ncol=3, nrow=dim(vecX)[1])
	Y = dummy(class)
	colnames(Y) = c("1", "2", "3")
	
	Xc = normalize(vecX)
	Xn = Xc$Xc
	Xval_vec_norm = normalizetest(t(apply(X_val,3, as.vector)),Xc)
	Xtest_vec_norm = normalizetest(t(apply(X_test,3, as.vector)),Xc)

	sda.val = matrix(0, nrow=length(stop.param), ncol=1)
	sda.test = matrix(0, nrow=length(stop.param), ncol=1)

	for(k in 1:length(stop.param)){
		out = try(sda(Xn, Y, stop = stop.param[k], maxIte = 25, trace = FALSE))
		if(out!="try-error"){
			sda.val[k,1] = sum(predict(out, Xval_vec_norm)$class != class_val)/length(class_val)
			sda.test[k,1] = sum(predict(out, Xtest_vec_norm)$class != class_test)/length(class_test)
		} else {
			sda.val[k,1] = NA
			sda.test[k,1] = NA
		}
	}

	sda.mc[kk] = sda.test[min(which(sda.val==min(sda.val[!is.na(sda.val)]))),1]

# ----------  Bayes Rule  	
	out.oracle = MN_CLASSIFICATION(X=X_test, class=class_test, M = Mu_Array, U = U, V = V, pi.list = rep(1/C, C))
	oracle.mc[kk] = out.oracle$misclass

# ---- Vectorize sample mean
	mean.array = array(0, dim=c(r, p, C))
	for(jjj in 1:C){
		mean.array[,,jjj] = apply(X[,,class==jjj], c(1,2), mean)
	}
	mean.vec = apply(mean.array, 3, as.vector)

# ------	Matrix-Normal MLE 
	outMLE = MN_MLE(X=X, class)
	V = outMLE$V
	U = outMLE$U
	mean.array = outMLE$Mean
	result = MN_CLASSIFICATION(X_test, class_test, 
		mean.array, U, V, pihat)
	MNlda.mc[kk] = result$misclass
	
# ----------  PMN; our proposal 
	fit.grid = MatLDA_Grid(X=X, class=class, lambda1=lambda1.prop, 
		lambda2=lambda2.prop, quiet=TRUE,
		Xval=X_val, classval= class_val,
		k.iter = 100, cov.tol=1e-5, m.tol=1e-5, full.tol=1e-6)

	CV.mat = fit.grid$Val.mat
	G.mat = fit.grid$G.mat*(CV.mat==min(CV.mat))
	ind1 = (which(G.mat==max(G.mat), arr.ind=TRUE))[,2]
	ind2 = (which(G.mat==max(G.mat), arr.ind=TRUE))[,1]
	out = unique(ind2[which(ind2==max(ind2))])
	lambda1.cv = lambda1.prop[out]
	out2 = unique(max(ind1[ind2==out]))
	lambda2.cv = lambda2.prop[out2]

	out = MatLDA(X=X, class=class, lambda1=lambda1.cv, 
		lambda2=lambda2.cv, quiet=TRUE,
		Xval=NULL, classval= NULL,
		k.iter = 100, cov.tol=1e-5, m.tol=1e-5, full.tol=1e-6)

	Uinv.est = out$Uinv
	Vinv.est = out$Vinv
	Mean = out$Mean
	result = PredictMN(out, newdata=X_test, newclass=class_test)
	propval.mc[kk] = result$misclass


	cat("## ------- rep ", kk, " complete ---- ", "\n")
	cat("Bayes=" , mean(oracle.mc[1:kk]), "\n")
	cat("MN_LDA=", mean(MNlda.mc[1:kk]), "\n")
	cat("Propval=", mean(propval.mc[1:kk]), "\n")
	cat("Witten=", mean(witten.mc[1:kk]), "\n")
	cat("MSDA=", mean(msda.mc[1:kk]), "\n")
	cat("SDA=", mean(sda.mc[1:kk]), "\n")

	
	named.list = function(...) { 
	  l = list(...)
	  names(l) = as.character( match.call()[-1] )
	  l
	}


	saveRDS(named.list(oracle.mc,
		MNlda.mc,
		propval.mc,
		witten.mc, 
		msda.mc, 
		sda.mc), 
		file=savename)

}


unlink(".RData")