packgs="library(plyr);
library(glasso);
library(Rcpp);
library(RcppArmadillo);
library(compiler);
library(sparseLDA);
library(dummies);
library(msda);
library(MASS);
library(penalizedLDA);
library(dummies);\n"


# ---- source functions from folder
sources= "source(\"Functions/SAMPLES.R\");
source(\"Functions/GENERAL_ITER.R\");
source(\"Functions/MN_CLASSIFICATION.R\");
source(\"Functions/MatLDA.R\");
source(\"Functions/MatLDA_Grid.R\");
source(\"Functions/MN_MLE.R\");
source(\"Functions/VS_CHECK.R\");
source(\"Functions/NORM_CLASSIFICATION_LDA.R\");
source(\"Functions/CREATE_DAT_COV1.R\");
sourceCpp(\"Functions/M_Update_Rcpp.cpp\");\n"

# ---- source simulation script
runsim="\nsource(\"Model1_Fisher_Main.R\")"
N = 75; N_test = 1000; N_validate = 75
reps = c(100, 100, 100, 100, 100)
seed.in = c(100, 100, 100, 100, 100)
C = 3 
r = c(8, 16, 32, 32, 32)
p = c(8, 16, 32, 16, 8)


lam.Wit = list(c(-8, 8),c(-8, 8),c(-8, 8),c(-8, 8),c(-8, 8))
stop.param = list(c(-1,-25),c(-1,-25),c(-1,-25),c(-1,-25),c(-1,-25))
lam1.prop = list(c(-5, 0),c(-5, 0), c(-4, 0),c(-4, 0),c(-4,0))
lam2.prop  = list(c(-10, -4),c(-11, -4), c(-8, -3), c(-8, -1),c(-8, -2))


# ---- write simulation files and execute -----------------
for(i in 1:length(r)){
  
	filename=paste("Model1_r", r[i], "p", p[i], "_Fisher", sep="")
	savename=paste("Model1_r", r[i], "p", p[i], "_Fisher.RDS", sep="")
	settings=paste("N = ", N, "; N_test = ", N_test, ";N_validate = ", N_validate, ";reps = ", reps[i], "; 
	seed = ", seed.in[i], "; r = ", r[i], "; p = ", p[i], "; C = ", C, ";\n 
	lambda1.Witten = c(2^seq(",lam.Wit[[i]][1],",",lam.Wit[[i]][2],", by=0.25));
	stop.param = ", stop.param[[i]][1],":",stop.param[[i]][2],"; 
	lambda1.prop = c(2^seq(",lam1.prop[[i]][1],",",lam1.prop[[i]][2],", by=0.5));
	lambda2.prop = c(2^seq(",lam2.prop[[i]][1],",",lam2.prop[[i]][2],", by=0.5));
	trans = FALSE; 
	savename=\"", savename, "\";\n", sep="")
	write(x=paste(packgs, sources, settings, runsim, sep=""), file=paste(filename, ".R", sep=""))
	# command=paste("nohup R --no-save < ",filename, ".R > out_", i, filename, ".txt &", sep="") 
	# system(command)
 
}






N = 75; N_test = 1000; N_validate = 75
reps = rep(1, 100)
seed.in = 1:100
C = 3 
r = rep(64, 100)
p = rep(64, 100)
lam.Wit = rep(list(c(-8, 8)),100)
stop.param = rep(list(c(-1,-25)),100)
lam1.prop = rep(list(c(-4, 0)),100)
lam2.prop  = rep(list(c(-9, -3)),100)


for(i in 1:length(r)){
  
	filename=paste("Model1_r", r[i], "p", p[i], "_Fisher_",i, sep="")
	savename=paste("Model1_r", r[i], "p", p[i], "_Fisher_",i,".RDS", sep="")
	settings=paste("N = ", N, "; N_test = ", N_test, ";N_validate = ", N_validate, ";reps = ", reps[i], "; 
	seed = ", seed.in[i], "; r = ", r[i], "; p = ", p[i], "; C = ", C, ";\n 
	lambda1.Witten = c(2^seq(",lam.Wit[[i]][1],",",lam.Wit[[i]][2],", by=0.25));
	stop.param = ", stop.param[[i]][1],":",stop.param[[i]][2],";
	lambda1.prop = c(2^seq(",lam1.prop[[i]][1],",",lam1.prop[[i]][2],", by=0.5));
	lambda2.prop = c(2^seq(",lam2.prop[[i]][1],",",lam2.prop[[i]][2],", by=0.5));
	trans = FALSE; 
	savename=\"", savename, "\";\n", sep="")
	write(x=paste(packgs, sources, settings, runsim, sep=""), file=paste(filename, ".R", sep=""))
	# command=paste("nohup R --no-save < ",filename, ".R > out_", i, filename, ".txt &", sep="") 
	# system(command)
 
}



N = 75; N_test = 1000; N_validate = 75
reps = rep(1, 200)
seed.in = c(1:100, 1:100) # -- change seed for r = 32, p = 126 by hand for replication 75  -> 101 (SDA fails)
C = 3 
r = c(rep(64,100), rep(126,100))
p = rep(32, 200)
lam.Wit = rep(list(c(-8, 8)), 200)
stop.param = rep(list(c(-1,-25)), 200)
lam1.prop = rep(list(c(-4, 0)), 200)
lam2.prop  = rep(list(c(-8, -4)), 200)

for(i in 1:length(r)){
	if(i <= 100){
		filename=paste("Model1_r", p[i], "p", r[i], "_Fisher_",i, sep="")
		savename=paste("Model1_r", p[i], "p", r[i], "_Fisher_",i,".RDS", sep="")
	} else {
		filename=paste("Model1_r", p[i], "p", r[i], "_Fisher_",i-100, sep="")
		savename=paste("Model1_r", p[i], "p", r[i], "_Fisher_",i-100,".RDS", sep="")
	}

	settings=paste("N = ", N, "; N_test = ", N_test, ";N_validate = ", N_validate, ";reps = ", reps[i], "; 
	seed = ", seed.in[i], "; r = ", r[i], "; p = ", p[i], "; C = ", C, ";\n 
	lambda1.Witten = c(2^seq(",lam.Wit[[i]][1],",",lam.Wit[[i]][2],", by=0.25));
	stop.param = ", stop.param[[i]][1],":",stop.param[[i]][2],";
	lambda1.prop = c(2^seq(",lam1.prop[[i]][1],",",lam1.prop[[i]][2],", by=0.5));
	lambda2.prop = c(2^seq(",lam2.prop[[i]][1],",",lam2.prop[[i]][2],", by=0.5));
	trans = TRUE; 
	savename=\"", savename, "\";\n", sep="")
	write(x=paste(packgs, sources, settings, runsim, sep=""), file=paste(filename, ".R", sep=""))
	# command=paste("nohup R --no-save < ",filename, ".R > out_", i, filename, ".txt &", sep="") 
	# system(command)
 
}

