# -----------------------------------------------
# Classify multivariate normal LDA
# ----------------------------------------------

NORM_CLASSIFICATION_LDA = function(X, class=NULL, pihat, Mean, SigmaInv){
	
	N_test = dim(X)[2]
	K = length(unique(class))
	class.mat = matrix(0, nrow=N_test, ncol=K)
	pred.class = numeric(length=N_test)
	out = list(NA)
	out2 = list(NA)
	# ------ store redundant computations
	for(k in 1:K){
		out[[k]] = crossprod(Mean[,k], crossprod(SigmaInv, Mean[,k]))
		out2[[k]] = crossprod(SigmaInv, Mean[,k])
	}
	
	# ----- compute MLE
	for(j in 1:N_test){
		for(k in 1:K){
			class.mat[j,k] =  crossprod(X[,j], out2[[k]]) - .5*out[[k]] + log(pihat[k])
		}
		pred.class[j] = which.max(class.mat[j,])
	}

	if(!is.null(class)){
		misclass = sum(pred.class != class)/N_test
	} else {
		misclass = NA
	}
	return(list("pred.class" = pred.class, "misclass" = misclass))
}


