# -------------------------------------------------------
# function to compute TNR/TPR
# --------------------------------------------------------
VS_CHECK = function(Mu_Array, G.array=NULL, mean.array = NULL){
	
	C = dim(Mu_Array)[3]
	C.total = (C*(C-1))/2

	TPR = matrix(0, nrow=C-1, ncol=C-1)
	TNR = matrix(0, nrow=C-1, ncol=C-1)

	if(is.null(mean.array)){
		for(nn in 1:(C-1)){
			for(mm in (nn+1):C){
				out1 = Mu_Array[,,nn] - Mu_Array[,,mm]
				TPR[nn, mm-1] = (length(intersect(which(G.array[,,nn,mm-1]!=0), which(out1!=0)))/sum(out1!=0))
				TNR[nn, mm-1] = (length(intersect(which(G.array[,,nn,mm-1]==0), which(out1==0)))/sum(out1==0))
			}
		}

	} else { 
		for(nn in 1:(C-1)){
			for(mm in (nn+1):C){
				out1 = Mu_Array[,,nn] - Mu_Array[,,mm]
				check1 = mean.array[,,nn] - mean.array[,,mm]
				TPR[nn, mm-1] = (length(intersect(which(check1!=0), which(out1!=0)))/sum(out1!=0))
				TNR[nn, mm-1] = (length(intersect(which(check1==0), which(out1==0)))/sum(out1==0))
			}
		}
	}

	TPR = mean(TPR[1,1], TPR[1,2], TPR[2,2])
	TNR = mean(TNR[1,1], TNR[1,2], TNR[2,2])
	return(list("TNR" = TNR, "TPR" = TPR))

}
