
set.seed(seed)

# -- assign memory ---
oracle.mc = rep(0, reps) 
SUREtuned.mc = rep(0, reps) 
SUREtuned.MN.mc = rep(0, reps)
GUO.mc = rep(0, reps)
MNlda.mc = rep(0, reps) 
oracle.xu.mc = rep(0, reps) 
propval.mc = rep(0, reps) 
oracle.propval.mc = rep(0, reps) 
SUREtuned.TNR = rep(0, reps)
SUREtuned.TPR = rep(0, reps)
SUREtuned.MN.TNR = rep(0, reps)
SUREtuned.MN.TPR = rep(0, reps)
GUO.TNR = rep(0, reps)
GUO.TPR = rep(0, reps)
oracle.xu.TNR = rep(0, reps)
oracle.xu.TPR = rep(0, reps)
propval.TPR = rep(0, reps)
propval.TNR = rep(0, reps)
require(compiler)
enableJIT(3)

for(kk in 1:reps){

# ------ create data
	if(!trans){
		dat1 = CREATE_DAT_COV1(r=r, p=p, C=3, rho.U = 0.5, rho.V = 0.5, 
			N=N, N_validate=N_validate, N_test=N_test)
	} else {
		dat1 = CREATE_DAT_COV1_TRANS(r=r, p=p, C=3, rho.U = 0.5, rho.V = 0.5, 
			N=N, N_validate=N_validate, N_test=N_test)
	}

# ----- rename created data
	X = dat1$X
	class = dat1$class
	X_val = dat1$X_val
	X_test = dat1$X_test
	U = dat1$U
	V = dat1$V

# ---- population mean
	Mu_Array = dat1$Mu_Array  # population 
	class_test = dat1$class_test
	class_val = dat1$class_val
	nc = count(class)[,2]
	pihat = nc/N  # sample estimate
	vecX_test = apply(X_test, 3, as.vector) 
	vecX_val = apply(X_val, 3, as.vector)

# ---- vectorize sample mean 
	mean.array = array(0, dim=c(r, p, C)) # sample array
	for(jjj in 1:C){
		mean.array[,,jjj] = apply(X[,,class==jjj], c(1,2), mean)
	}
	mean.vec = apply(mean.array, 3, as.vector) # sample vectorized

# ---------   Bayes Rule  
	out.oracle = MN_CLASSIFICATION(X=X_test, class=class_test, M = Mu_Array, U = U, V = V, pi.list = rep(1/C, C))
	oracle.mc[kk] = out.oracle$misclass

# --------    SURE-SCREENED multiclass LDA 
	out = SURE_SCREEN(X = X, class = class, X_val = X_val, class_val = class_val, X_test = X_test, class_test = class_test)
	SUREtuned.mc[kk] = out$tuned.misclass.rate
	SUREtuned.MN.mc[kk] = out$tuned.MN.misclass.rate
	
	vs.tuned = VS_CHECK(Mu_Array = Mu_Array, G.array = out$G.array.tuned)
	SUREtuned.TNR[kk] = vs.tuned$TNR
	SUREtuned.TPR[kk] = vs.tuned$TPR
	
	vs.MN = VS_CHECK(Mu_Array = Mu_Array, G.array = out$G.array.tuned.MN)
	SUREtuned.MN.TNR[kk] = vs.MN$TNR
	SUREtuned.MN.TPR[kk] = vs.MN$TPR

# --------------   Guo (2010)  -----
	out.Guo = rep(0, length(lambda.guo))
	
 	for (h in 1:length(lambda.guo)){
		if (h==1){
			out = GUO_L1_NB(X = X, class = class, lambda=lambda.guo[h], quiet=TRUE)
		} else { 
			out = GUO_L1_NB(X = X, class = class, lambda=lambda.guo[h], quiet=TRUE, warm=TRUE, beta = t(mean.mat.guo))
		}
		mean.mat.guo = t(out$mean.matrix)
		SigmaInv = diag(diag(out$Sigma_diag)^(-1))
		out.Guo[h] =  NORM_CLASSIFICATION_LDA(X=vecX_val, class=class_val, pihat = pihat, Mean = mean.mat.guo, SigmaInv = SigmaInv)$misclass
	}

	tp = max(which(out.Guo == min(out.Guo)))
	out = GUO_L1_NB(X = X, class = class, lambda = lambda.guo[tp], quiet=TRUE)
	mean.mat.guo = t(out$mean.matrix)
	SigmaInv = diag(diag(out$Sigma_diag)^(-1))
	result =  NORM_CLASSIFICATION_LDA(X = vecX_test, class = class_test, pihat = pihat, Mean = mean.mat.guo, SigmaInv = SigmaInv)
	GUO.mc[kk] = result$misclass

	mean.array.guo = array(0, dim=c(r, p, C))
	for(c in 1:C){
		mean.array.guo[,,c] = matrix(mean.mat.guo[,c], nrow=r, byrow=F)
	}

	Guo.vs = VS_CHECK(Mu_Array = Mu_Array, mean.array = mean.array.guo)
	GUO.TNR[kk] = Guo.vs$TNR
	GUO.TPR[kk] = Guo.vs$TPR

# --------   Matrix-Normal MLE  ----------
	outMLE = MN_MLE(X=X, class=class)
	out = MN_CLASSIFICATION(X = X_test, class = class_test, pi.list = pihat, M = mean.array, U = outMLE$U, V = outMLE$V)
	MNlda.mc[kk] = out$misclass

# ------- PMN(Sigma); part-oracle Xu  --------	
	fit.grid = KRON_XU_GRID(X, class, U=U, V=V, 
		lambda1=lambda1.Xu, Xval=X_val, classval = class_val)

	G.mat = fit.grid$G.mat*(fit.grid$Val.mat==min(fit.grid$Val.mat))
	lambda1.cv = lambda1.Xu[max((which(G.mat==max(G.mat), arr.ind=TRUE))[,1])]

	out = KRON_XU(X, class, U=U, V=V, 
		lambda1=lambda1.cv, Xval=X_test, classval = class_test)

	oracle.xu.mc[kk] = out$Val.mat
	Kron.vs = VS_CHECK(Mu_Array = Mu_Array, mean.array = out$Mean)
	oracle.xu.TNR[kk] = Kron.vs$TNR
	oracle.xu.TPR[kk] = Kron.vs$TPR

# ---------  PMN; our proposal  -----------------
	fit.grid = MatLDA_Grid(X=X, class=class, lambda1=lambda1.prop, lambda2=lambda2.prop, quiet=TRUE,
		Xval=X_val, classval= class_val, k.iter = 100, cov.tol=1e-5, m.tol=1e-5, full.tol=1e-6)
	
	G.mat = fit.grid$G.mat*(fit.grid$Val.mat==min(fit.grid$Val.mat))
	ind1 = which(G.mat==max(G.mat), arr.ind=TRUE)[,2]
	ind2 = which(G.mat==max(G.mat), arr.ind=TRUE)[,1]
	out = unique(ind2[which(ind2==max(ind2))])
	lambda1.cv = lambda1.prop[out]
	out2 = unique(max(ind1[ind2==out]))
	lambda2.cv = lambda2.prop[out2]
	
	out = MatLDA(X=X, class=class, lambda1=lambda1.cv, 
		lambda2=lambda2.cv, quiet=FALSE,
		Xval=NULL, classval= NULL,
		k.iter = 100, cov.tol=1e-5, m.tol=1e-5, full.tol=1e-6)

	result = PredictMN(out, newdata=X_test, newclass=class_test)
	propval.mc[kk] = result$misclass
	prop.vs = VS_CHECK(Mu_Array = Mu_Array, mean.array = out$Mean)
	propval.TNR[kk] = prop.vs$TNR
	propval.TPR[kk] = prop.vs$TPR


# -------- PMN(M);  population means known -----
	fit.grid = ORACLE_MEAN_GRID(X = X, class = class, Mean = Mu_Array, 
		lambda2 = lambda2.mu, quiet=TRUE, Xval = X_val, classval = class_val)

	lambda2.cv = lambda2.mu[max(which(fit.grid$Val.mat == min(fit.grid$Val.mat), arr.ind=TRUE)[,2])]

	out = ORACLE_MEAN_SINGLE(X = X, class = class, Mean = Mu_Array, 
		lambda2=lambda2.cv, quiet=TRUE, Xval=X_test, 
		classval= class_test)

	oracle.propval.mc[kk] = out$Val


# -------- print results after each replication ---- 
	cat("## ----- rep ", kk, " complete ---- ", "\n")
	cat("Bayes = " , mean(oracle.mc[1:kk]), "\n")
	cat("MN_LDA = ", mean(MNlda.mc[1:kk]), "\n")
	cat("Propval = ", mean(propval.mc[1:kk]), "\n")
	cat("Guo_LDA = ", mean(GUO.mc[1:kk]), "\n")
	cat("SURE = ", mean(SUREtuned.mc[1:kk]), "\n")
	cat("SURE_MN = ", mean(SUREtuned.MN.mc[1:kk]), "\n")

	named.list = function(...) { 
	  l = list(...)
	  names(l) = as.character( match.call()[-1] )
	  l
	}


	saveRDS(named.list(oracle.mc,
		SUREtuned.mc,
		SUREtuned.MN.mc,
		GUO.mc,
		MNlda.mc,
		oracle.xu.mc,
		propval.mc,
		oracle.propval.mc,
		SUREtuned.TNR,
		SUREtuned.TPR,
		SUREtuned.MN.TNR,
		SUREtuned.MN.TPR,
		GUO.TNR,
		GUO.TPR,
		oracle.xu.TNR,
		oracle.xu.TPR,
		propval.TPR,
		propval.TNR),
	file=savename)

}


rm(list = ls())

q("no")