
set.seed(seed)

oracle.mc = rep(0, reps) 
SUREtuned.mc = rep(0, reps) 
SUREtuned.MN.mc = rep(0, reps)
GUO.mc = rep(0, reps)
MNlda.mc = rep(0, reps) 
oracle.xu.mc = rep(0, reps) 
propval.mc = rep(0, reps) 
oracle.propval.mc = rep(0, reps) 
SUREtuned.TNR = rep(0, reps)
SUREtuned.TPR = rep(0, reps)
SUREtuned.MN.TNR = rep(0, reps)
SUREtuned.MN.TPR = rep(0, reps)
GUO.TNR = rep(0, reps)
GUO.TPR = rep(0, reps)
oracle.xu.TNR = rep(0, reps)
oracle.xu.TPR = rep(0, reps)
propval.TPR = rep(0, reps)
propval.TNR = rep(0, reps)

require(compiler)
enableJIT(3)

# ----- generate covariance  -----
rho = seq(.5, .9, length=p)
Sigma = matrix(0, nrow=r*p, ncol=r*p)
for(jj in 1:p){
	for(j in 1:r){
		for(hh in 1:p){
			for(h in 1:r){
				Sigma[(jj-1)*r + j,(hh-1)*r + h] = (.5*(jj!=hh) + (jj==hh))*((rho[jj]*rho[hh])^(abs(h-j)))/(1 - rho[jj]*rho[hh])
			}
		}
	}
}

# ---------------------------------
eo = eigen(Sigma)
Sigma.sqrt = tcrossprod(tcrossprod(eo$vec,(diag((eo$val)^(1/2)))),eo$vec)
SigmaInv.Oracle = chol2inv(chol(Sigma))
rho.input = max(eo$val)
# --------------------------------


for(kk in 1:reps){

# ------ generate mean matrices
	Mu_Array = array(0, dim=c(r, p, 3))
	c1 = sample(0:(r-4), 1)
	c2 = sample(0:(p-4), 1)	
	Mu_Array[(1:2)+c1, (1:2)+c2, 1] = 1
	Mu_Array[(3:4)+c1, (3:4)+c2, 2] = -1.5
	Mu_Array[(1:2)+c1, (1:2)+c2, 3] = -2
	Mu_Array[(3:4)+c1, (3:4)+c2, 3] = -0.5
	Mu_Vec = apply(Mu_Array, 3, as.vector)

# ---- allocate memory 
	N_total = N + N_validate + N_test
	dat.vectorized = matrix(0, nrow=N_total, ncol=r*p)
	dat.array = array(0, dim=c(r, p, N_total))
	class_total = rep(0, length=N_total)

# ------ generate multivariate normal data -----
	for(jj in 1:N_total){

		class_total[jj] = sample(1:C, 1, prob=rep(1/C, C))
		dat.vectorized[jj,] =  crossprod(Sigma.sqrt, matrix(rnorm(r*p), nrow=r*p)) + Mu_Vec[,class_total[jj]]
		dat.array[,,jj] = matrix(dat.vectorized[jj,], nrow=r, ncol=p, byrow=FALSE) # reverse vectorization 

	}

# --- Create matrix-variate data ---------------
	X = dat.array[,,1:N]
	X_val = dat.array[,,(N+1):(N+N_validate)]
	X_test = dat.array[,,(N+N_validate+1):N_total]
	class = class_total[1:N]
	class_val = class_total[(N+1):(N+N_validate)]
	class_test = class_total[(N+N_validate+1):N_total]
	nc = count(class)[,2]
	pihat = nc/N
	vecX_test = apply(X_test, 3, as.vector)
	vecX_val = apply(X_val, 3, as.vector)

# --- create transposed data for our method if r > p ---- 
	if(r == 32 & p == 64){

		X.trans <- array(0, dim=c(p, r, N))
		X_val.trans <- array(0, dim=c(p, r, N_validate))
		X_test.trans <- array(0, dim=c(p, r, N_test))
		Mu_Array.trans <- array(0, dim=c(p, r, 3))

		for(jj in 1:N){
			X.trans[,,jj] <- t(X[,,jj])
		}

		for(jj in 1:N_validate){
			X_val.trans[,,jj] <- t(X_val[,,jj])
		}
	
		for(jj in 1:N_test){
			X_test.trans[,,jj] <- t(X_test[,,jj])
		}

		for(jj in 1:3){
			Mu_Array.trans[,,jj] <- t(Mu_Array[,,jj])
		}
		
	}

# ------ vectorize sample mean
	mean.array = array(0, dim=c(r, p, C))
	for(jjj in 1:C){
		mean.array[,,jjj] = apply(X[,,class==jjj], c(1,2), mean)
	}
	mean.vec = apply(mean.array, 3, as.vector)

# ---------   Bayes Rule  
	out.oracle =  NORM_CLASSIFICATION_LDA(X=vecX_test, class=class_test, pihat = rep(1/C, C), Mean = Mu_Vec, SigmaInv = SigmaInv.Oracle)
	oracle.mc[kk] = out.oracle$misclass
	
# --------    SURE-SCREENED multiclass LDA 
	out = SURE_SCREEN(X, class, X_val, class_val, X_test, class_test)
	SUREtuned.mc[kk] = out$tuned.misclass.rate
	SUREtuned.MN.mc[kk] = out$tuned.MN.misclass.rate
	vs.tuned = VS_CHECK(Mu_Array = Mu_Array, G.array = out$G.array.tuned)
	SUREtuned.TNR[kk] = vs.tuned$TNR
	SUREtuned.TPR[kk] = vs.tuned$TPR
	vs.MN = VS_CHECK(Mu_Array = Mu_Array, G.array = out$G.array.tuned.MN)
	SUREtuned.MN.TNR[kk] = vs.MN$TNR
	SUREtuned.MN.TPR[kk] = vs.MN$TPR

# --------------   Guo (2010)  
	out.Guo = numeric(length = length(lambda.guo))
 	for (h in 1:length(lambda.guo)){
		if (h==1){
			out = GUO_L1_NB(X, class, lambda=lambda.guo[h], quiet=TRUE)
		} else { 
			out = GUO_L1_NB(X, class, lambda=lambda.guo[h], quiet=TRUE, warm=TRUE, beta = t(mean.mat.guo))
		}
		mean.mat.guo = t(out$mean.matrix)
		out.Guo[h] =  NORM_CLASSIFICATION_LDA(X=vecX_val, class=class_val, pihat = pihat, Mean = mean.mat.guo, SigmaInv = diag(diag(out$Sigma_diag)^(-1)))$misclass
	}

	tp = max(which(out.Guo == min(out.Guo)))
	out = GUO_L1_NB(X, class, lambda.guo[tp], quiet=TRUE)
	mean.mat.guo = t(out$mean.matrix)
	result =  NORM_CLASSIFICATION_LDA(X=vecX_test, class=class_test, pihat = pihat, Mean = mean.mat.guo, SigmaInv = diag(diag(out$Sigma_diag)^(-1)))
	GUO.mc[kk] = result$misclass
	mean.array.guo = array(0, dim=c(r, p, C))
	for(c in 1:C){
		mean.array.guo[,,c] = matrix(mean.mat.guo[,c], nrow=r, byrow=F)
	}
	guo.vs = VS_CHECK(Mu_Array = Mu_Array, mean.array = mean.array.guo)
	GUO.TNR[kk] = guo.vs$TNR
	GUO.TPR[kk] = guo.vs$TPR

# --------   Matrix-Normal MLE  -------
	if(r == 32 & p == 64){

		outMLE = MN_MLE(X=X.trans, class = class)
		result = MN_CLASSIFICATION(X = X_test.trans, class = class_test, 
			M = outMLE$Mean, U = outMLE$U, V = outMLE$V, pi.list=pihat)
		MNlda.mc[kk] = result$misclass

	} else {

		outMLE = MN_MLE(X=X, class = class)
		result = MN_CLASSIFICATION(X = X_test, class = class_test, 
			M = outMLE$Mean, U = outMLE$U, V = outMLE$V, pi.list=pihat)
		MNlda.mc[kk] = result$misclass
	}

# ------- PMN(Sigma); part-oracle Xu   -----
	temp <- XU_SIGMA_GRID(X= X, class= class, Sigma = Sigma, Omega = SigmaInv.Oracle, 
		lambda = lambda1.Xu, X_val = X_val, class_val = class_val, X_test = X_test, 
		class_test = class_test, Mu_Array = Mu_Array, rho.input = rho.input)
	Xu.ind <- max(which(temp$Val.mat == min(temp$Val.mat)))
	oracle.xu.mc[kk] = temp$Test.mat[Xu.ind]
	oracle.xu.TPR[kk] = temp$TPR.set[Xu.ind]
	oracle.xu.TNR[kk] = temp$TNR.set[Xu.ind]

# ---------  PMN; our proposal  -----------------
	if(r == 32 & p == 64){
		fit.grid = MatLDA_Grid(X=X.trans, class=class, lambda1=lambda1.prop, lambda2=lambda2.prop, quiet=TRUE,
			Xval=X_val.trans, classval= class_val, k.iter = 100, cov.tol=1e-5, m.tol=1e-5, full.tol=1e-6)
	} else {
		fit.grid = MatLDA_Grid(X=X, class=class, lambda1=lambda1.prop, lambda2=lambda2.prop, quiet=TRUE,
			Xval=X_val, classval= class_val, k.iter = 100, cov.tol=1e-5, m.tol=1e-5, full.tol=1e-6)
	}

	CV.mat = fit.grid$Val.mat
	G.mat = fit.grid$G.mat*(CV.mat==min(CV.mat))
	ind1 = which(G.mat==max(G.mat), arr.ind=TRUE)[,2]
	ind2 = which(G.mat==max(G.mat), arr.ind=TRUE)[,1]
	out = unique(ind2[which(ind2 == max(ind2))])
	lambda1.cv = lambda1.prop[out]
	out2 = unique(max(ind1[ind2 == out]))
	lambda2.cv = lambda2.prop[out2]
	

	if(r == 32 & p == 64){

		out = MatLDA(X=X.trans, class=class, lambda1=lambda1.cv, 
			lambda2=lambda2.cv, quiet=TRUE,
			Xval=NULL, classval= NULL,
			k.iter = 100, cov.tol=1e-5, m.tol=5e-6, full.tol=1e-6)

		result = PredictMN(out, newdata=X_test.trans, newclass=class_test)
		propval.mc[kk] = result$misclass

		vs.val = VS_CHECK(Mu_Array = Mu_Array.trans, mean.array = out$Mean)
		propval.TNR[kk] = vs.val$TNR
		propval.TPR[kk] = vs.val$TPR

	} else {

		out = MatLDA(X=X, class=class, lambda1=lambda1.cv, 
			lambda2=lambda2.cv, quiet=TRUE,
			Xval=NULL, classval= NULL,
			k.iter = 100, cov.tol=1e-5, m.tol=5e-6, full.tol=1e-6)

		result = PredictMN(out, newdata=X_test, newclass=class_test)
		propval.mc[kk] = result$misclass

		vs.val = VS_CHECK(Mu_Array = Mu_Array, mean.array = out$Mean)
		propval.TNR[kk] = vs.val$TNR
		propval.TPR[kk] = vs.val$TPR
	}


# -------- PMN(M);  population means known -----
	if(r == 32 & p == 64){
		fit.grid = ORACLE_MEAN_GRID(X=X.trans, class=class, Mean = Mu_Array.trans, lambda2=lambda2.mu, 
			quiet=TRUE, Xval=X_val.trans, classval= class_val)
	} else {
		fit.grid = ORACLE_MEAN_GRID(X=X, class=class, Mean = Mu_Array, lambda2=lambda2.mu, 
			quiet=TRUE, Xval=X_val, classval= class_val)
	}

	CV.mat = fit.grid$Val.mat
	lambda2.cv = lambda2.mu[max(which(CV.mat==min(CV.mat), arr.ind=TRUE)[,1])]


	if(r == 32 & p == 64){
		out = ORACLE_MEAN_SINGLE(X = X.trans, class = class, Mean= Mu_Array.trans, 
		lambda2=lambda2.cv, quiet=TRUE, Xval=X_test.trans, 
		classval= class_test)
	} else {
		out = ORACLE_MEAN_SINGLE(X=X, class = class, Mean=Mu_Array, 
		lambda2=lambda2.cv, quiet=TRUE, Xval=X_test, 
		classval= class_test)
	}
	oracle.propval.mc[kk] = out$Val

# -------- print results after each replication
	cat("## ----- rep ", kk, " complete ---- ", "\n")
	cat("Bayes = " , mean(oracle.mc[1:kk]), "\n")
	cat("MN_LDA = ", mean(MNlda.mc[1:kk]), "\n")
	cat("Propval = ", mean(propval.mc[1:kk]), "\n")
	cat("Guo_LDA = ", mean(GUO.mc[1:kk]), "\n")
	cat("SURE = ", mean(SUREtuned.mc[1:kk]), "\n")
	cat("SURE_MN = ", mean(SUREtuned.MN.mc[1:kk]), "\n")


	named.list = function(...) { 
	  l = list(...)
	  names(l) = as.character( match.call()[-1] )
	  l
	}

	saveRDS(named.list(oracle.mc,
		SUREtuned.mc,
		SUREtuned.MN.mc,
		GUO.mc,
		MNlda.mc,
		oracle.xu.mc,
		propval.mc,
		oracle.propval.mc,
		SUREtuned.TNR,
		SUREtuned.TPR,
		SUREtuned.MN.TNR,
		SUREtuned.MN.TPR,
		GUO.TNR,
		GUO.TPR,
		oracle.xu.TNR,
		oracle.xu.TPR,
		propval.TPR,
		propval.TNR), 
	file=savename)

}

rm(list = ls())

q("no")