setwd("/Users/aaronmolstad/Desktop/Model4")
verticalize = function(x, y){
	g = length(x)
	out.vec = matrix(0, nrow=g, ncol=1)
	for(j in 1:g){
		out.vec[j,] = paste(round(signif(x[j], 3), 3), paste("footnotesize(", round(signif(y[j], 3), 2), ")"))
	}
	return(out.vec)
}

collateTPR_TNR = function(x, y){
	g = length(x[1,])
	out.vec = matrix(0, nrow=g, ncol=1)
	for(j in 1:g){
		out.vec[j,] = paste(signif(x[1,j], 3),"/", signif(y[1,j], 3))
	}
	return(out.vec)
}

# ------------------------------------------------------------------------
#
#   r = c  -- simulations 
#
# ------------------------------------------------------------------------



library(xtable)
oracle = NULL
veclda = NULL
vecNB = NULL
MNLDA = NULL
GUO = NULL
SURE = NULL
propval = NULL
SUREMN = NULL
XU = NULL
OrMean = NULL

temp = readRDS("Model4_r8p8.RDS")

mod1r8p8_TNR = rbind(c(mean(temp$GUO.TNR), mean(temp$SUREtuned.TNR), mean(temp$SUREtuned.MN.TNR), mean(temp$oracle.xu.TNR), mean(temp$propval.TNR))*100,
	c(sd(temp$GUO.TNR), sd(temp$SUREtuned.TNR), sd(temp$SUREtuned.MN.TNR), sd(temp$oracle.xu.TNR), sd(temp$propval.TNR))*10)

mod1r8p8_TPR = rbind(c(mean(temp$GUO.TPR), mean(temp$SUREtuned.TPR), mean(temp$SUREtuned.MN.TPR), mean(temp$oracle.xu.TPR), mean(temp$propval.TPR))*100,
	c(sd(temp$GUO.TPR), sd(temp$SUREtuned.TPR), sd(temp$SUREtuned.MN.TPR), sd(temp$oracle.xu.TPR), sd(temp$propval.TPR))*10)

vert_mod1r8p8_VS = collateTPR_TNR(mod1r8p8_TNR, mod1r8p8_TPR)

oracle = c(oracle, mean(temp$oracle.mc))
MNLDA = c(MNLDA, mean(temp$MNlda.mc))
GUO = c(GUO, mean(temp$GUO.mc))
SURE = c(SURE, mean(temp$SUREtuned.mc))
propval = c(propval, mean(temp$propval.mc))
SUREMN = c(SUREMN, mean(temp$SUREtuned.MN.mc))
XU = c(XU, mean(temp$oracle.xu.mc))
OrMean = c(OrMean, mean(temp$oracle.propval.mc))
temp = NULL

# ---------------------------------

temp = readRDS("Model4_r16p16.RDS")

mod1r16p16_TNR = rbind(c(mean(temp$GUO.TNR), mean(temp$SUREtuned.TNR), mean(temp$SUREtuned.MN.TNR), mean(temp$oracle.xu.TNR), mean(temp$propval.TNR))*100,
	c(sd(temp$GUO.TNR), sd(temp$SUREtuned.TNR), sd(temp$SUREtuned.MN.TNR), sd(temp$oracle.xu.TNR), sd(temp$propval.TNR))*10)

mod1r16p16_TPR = rbind(c(mean(temp$GUO.TPR), mean(temp$SUREtuned.TPR), mean(temp$SUREtuned.MN.TPR), mean(temp$oracle.xu.TPR), mean(temp$propval.TPR))*100,
	c(sd(temp$GUO.TPR), sd(temp$SUREtuned.TPR), sd(temp$SUREtuned.MN.TPR), sd(temp$oracle.xu.TPR), sd(temp$propval.TPR))*10)

vert_mod1r16p16_VS = collateTPR_TNR(mod1r16p16_TNR, mod1r16p16_TPR)

oracle = c(oracle, mean(temp$oracle.mc))
MNLDA = c(MNLDA, mean(temp$MNlda.mc))
GUO = c(GUO, mean(temp$GUO.mc))
SURE = c(SURE, mean(temp$SUREtuned.mc))
propval = c(propval, mean(temp$propval.mc))
SUREMN = c(SUREMN, mean(temp$SUREtuned.MN.mc))
XU = c(XU, mean(temp$oracle.xu.mc))
OrMean = c(OrMean, mean(temp$oracle.propval.mc))
temp = NULL

# ---------------------------------

temp = readRDS("Model4_r32p32.RDS")## for misclass table

mod1r32p32_TNR = rbind(c(mean(temp$GUO.TNR), mean(temp$SUREtuned.TNR), mean(temp$SUREtuned.MN.TNR), mean(temp$oracle.xu.TNR), mean(temp$propval.TNR))*100,
	c(sd(temp$GUO.TNR), sd(temp$SUREtuned.TNR), sd(temp$SUREtuned.MN.TNR), sd(temp$oracle.xu.TNR), sd(temp$propval.TNR))*10)

mod1r32p32_TPR = rbind(c(mean(temp$GUO.TPR), mean(temp$SUREtuned.TPR), mean(temp$SUREtuned.MN.TPR), mean(temp$oracle.xu.TPR), mean(temp$propval.TPR))*100,
	c(sd(temp$GUO.TPR), sd(temp$SUREtuned.TPR), sd(temp$SUREtuned.MN.TPR), sd(temp$oracle.xu.TPR), sd(temp$propval.TPR))*10)

vert_mod1r32p32_VS = collateTPR_TNR(mod1r32p32_TNR, mod1r32p32_TPR)

oracle = c(oracle, mean(temp$oracle.mc))
MNLDA = c(MNLDA, mean(temp$MNlda.mc))
GUO = c(GUO, mean(temp$GUO.mc))
SURE = c(SURE, mean(temp$SUREtuned.mc))
propval = c(propval, mean(temp$propval.mc))
SUREMN = c(SUREMN, mean(temp$SUREtuned.MN.mc))
XU = c(XU, mean(temp$oracle.xu.mc))
OrMean = c(OrMean, mean(temp$oracle.propval.mc))
temp = NULL


# ---------------------------------

temp.tot = list(NA)
for(k in 1:100){
	filename = paste("Model4_r64p64_", k, ".RDS", sep="")
	temp = readRDS(filename)
	temp.tot[[k]] = temp
}
temp.tot = matrix(unlist(temp.tot), nrow=length(names(temp)), ncol=100, byrow=FALSE)
temp.tot = as.data.frame(t(temp.tot))
names(temp.tot) = names(temp)
temp = temp.tot


mod1r64p64_TNR = rbind(c(mean(temp$GUO.TNR), mean(temp$SUREtuned.TNR), mean(temp$SUREtuned.MN.TNR), mean(temp$oracle.xu.TNR), mean(temp$propval.TNR))*100,
	c(sd(temp$GUO.TNR), sd(temp$SUREtuned.TNR), sd(temp$SUREtuned.MN.TNR), sd(temp$oracle.xu.TNR), sd(temp$propval.TNR))*10)
mod1r64p64_TPR = rbind(c(mean(temp$GUO.TPR), mean(temp$SUREtuned.TPR), mean(temp$SUREtuned.MN.TPR), mean(temp$oracle.xu.TPR), mean(temp$propval.TPR))*100,
	c(sd(temp$GUO.TPR), sd(temp$SUREtuned.TPR), sd(temp$SUREtuned.MN.TPR), sd(temp$oracle.xu.TPR), sd(temp$propval.TPR))*10)
vert_mod1r64p64_VS = collateTPR_TNR(mod1r64p64_TNR, mod1r64p64_TPR)

oracle = c(oracle, mean(temp$oracle.mc))
MNLDA = c(MNLDA, mean(temp$MNlda.mc))
GUO = c(GUO, mean(temp$GUO.mc))
SURE = c(SURE, mean(temp$SUREtuned.mc))
propval = c(propval, mean(temp$propval.mc))
SUREMN = c(SUREMN, mean(temp$SUREtuned.MN.mc))
XU = c(XU, mean(temp$oracle.xu.mc))
OrMean = c(OrMean, mean(temp$oracle.propval.mc))




pdf("Model4_Square.pdf", width=4, height=3.5)
#par(xpd=T, mar=c(4.1,4.1,2.1,1.1))
par(xpd=T, mar=c(4.1,4.1,1.6,1.1))
plot(c(1, 2, 3, 4), oracle, ylab = "Average misclassification rate", col="black", xlab=expression("(r,c)"),  type="b", lty=1, pch=8, ylim=c(0, .42), axes=FALSE)
axis(1, at=c(1, 2, 3, 4), labels=c("(8,8)", "(16,16)", "(32,32)", "(64,64)"))
axis(2, at=seq(0, .4, by=.1))
lines(c(1, 2, 3, 4), MNLDA, lty=1, pch=16, type="b")
lines(c(1, 2, 3, 4), GUO, lty=3, pch=3,  type="b")
lines(c(1, 2, 3, 4), SURE, lty=3, pch = 4, type="b")
lines(c(1, 2, 3, 4), SUREMN, lty=3, pch=5, type="b")
lines(c(1, 2, 3, 4), XU, lty=5, pch=2, type="b", col="darkgray")
lines(c(1, 2, 3, 4), OrMean, lty=5, pch=3, type="b", col="darkgray")
lines(c(1, 2, 3, 4), propval, lty=1, pch=15,type="b", col="black")
dev.off()






# ------------------------------------------------------------------------
#
#
#   r = 32, c varying -- simulations 
#
#
# ------------------------------------------------------------------------


library(xtable)
oracle = NULL
veclda = NULL
vecNB = NULL
MNLDA = NULL
GUO = NULL
SURE = NULL
propval = NULL
SUREMN = NULL
XU = NULL
OrMean = NULL

# ---------------------------------

temp = readRDS("Model4_r32p8.RDS")

mod1r32p8_TNR = rbind(c(mean(temp$GUO.TNR), mean(temp$SUREtuned.TNR), mean(temp$SUREtuned.MN.TNR), mean(temp$oracle.xu.TNR), mean(temp$propval.TNR))*100,
	c(sd(temp$GUO.TNR), sd(temp$SUREtuned.TNR), sd(temp$SUREtuned.MN.TNR), sd(temp$oracle.xu.TNR), sd(temp$propval.TNR))*10)

mod1r32p8_TPR = rbind(c(mean(temp$GUO.TPR), mean(temp$SUREtuned.TPR), mean(temp$SUREtuned.MN.TPR), mean(temp$oracle.xu.TPR), mean(temp$propval.TPR))*100,
	c(sd(temp$GUO.TPR), sd(temp$SUREtuned.TPR), sd(temp$SUREtuned.MN.TPR), sd(temp$oracle.xu.TPR), sd(temp$propval.TPR))*10)

vert_mod1r32p8_VS = collateTPR_TNR(mod1r32p8_TNR, mod1r32p8_TPR)

oracle = c(oracle, mean(temp$oracle.mc))
MNLDA = c(MNLDA, mean(temp$MNlda.mc))
GUO = c(GUO, mean(temp$GUO.mc))
SURE = c(SURE, mean(temp$SUREtuned.mc))
propval = c(propval, mean(temp$propval.mc))
SUREMN = c(SUREMN, mean(temp$SUREtuned.MN.mc))
XU = c(XU, mean(temp$oracle.xu.mc))
OrMean = c(OrMean, mean(temp$oracle.propval.mc))
temp = NULL

# ---------------------------------

temp = readRDS("Model4_r32p16.RDS")
mod1r32p16_TNR = rbind(c(mean(temp$GUO.TNR), mean(temp$SUREtuned.TNR), mean(temp$SUREtuned.MN.TNR), mean(temp$oracle.xu.TNR), mean(temp$propval.TNR))*100,
	c(sd(temp$GUO.TNR), sd(temp$SUREtuned.TNR), sd(temp$SUREtuned.MN.TNR), sd(temp$oracle.xu.TNR), sd(temp$propval.TNR))*10)

mod1r32p16_TPR = rbind(c(mean(temp$GUO.TPR), mean(temp$SUREtuned.TPR), mean(temp$SUREtuned.MN.TPR), mean(temp$oracle.xu.TPR), mean(temp$propval.TPR))*100,
	c(sd(temp$GUO.TPR), sd(temp$SUREtuned.TPR), sd(temp$SUREtuned.MN.TPR), sd(temp$oracle.xu.TPR), sd(temp$propval.TPR))*10)

vert_mod1r32p16_VS = collateTPR_TNR(mod1r32p16_TNR, mod1r32p16_TPR)

oracle = c(oracle, mean(temp$oracle.mc))
MNLDA = c(MNLDA, mean(temp$MNlda.mc))
GUO = c(GUO, mean(temp$GUO.mc))
SURE = c(SURE, mean(temp$SUREtuned.mc))
propval = c(propval, mean(temp$propval.mc))
SUREMN = c(SUREMN, mean(temp$SUREtuned.MN.mc))
XU = c(XU, mean(temp$oracle.xu.mc))
OrMean = c(OrMean, mean(temp$oracle.propval.mc))
temp = NULL

# ---------------------------------

temp = readRDS("Model4_r32p32.RDS")## for misclass table

mod1r32p32_TNR = rbind(c(mean(temp$GUO.TNR), mean(temp$SUREtuned.TNR), mean(temp$SUREtuned.MN.TNR), mean(temp$oracle.xu.TNR), mean(temp$propval.TNR))*100,
	c(sd(temp$GUO.TNR), sd(temp$SUREtuned.TNR), sd(temp$SUREtuned.MN.TNR), sd(temp$oracle.xu.TNR), sd(temp$propval.TNR))*10)

mod1r32p32_TPR = rbind(c(mean(temp$GUO.TPR), mean(temp$SUREtuned.TPR), mean(temp$SUREtuned.MN.TPR), mean(temp$oracle.xu.TPR), mean(temp$propval.TPR))*100,
	c(sd(temp$GUO.TPR), sd(temp$SUREtuned.TPR), sd(temp$SUREtuned.MN.TPR), sd(temp$oracle.xu.TPR), sd(temp$propval.TPR))*10)

vert_mod1r32p32_VS = collateTPR_TNR(mod1r32p32_TNR, mod1r32p32_TPR)

oracle = c(oracle, mean(temp$oracle.mc))
MNLDA = c(MNLDA, mean(temp$MNlda.mc))
GUO = c(GUO, mean(temp$GUO.mc))
SURE = c(SURE, mean(temp$SUREtuned.mc))
propval = c(propval, mean(temp$propval.mc))
SUREMN = c(SUREMN, mean(temp$SUREtuned.MN.mc))
XU = c(XU, mean(temp$oracle.xu.mc))
OrMean = c(OrMean, mean(temp$oracle.propval.mc))
temp = NULL


# ---------------------------------
temp.tot = list(NA)
for(k in 1:100){
	filename = paste("Model4_r32p64_", k, ".RDS", sep="")
	temp = readRDS(filename)
	temp.tot[[k]] = temp
}

temp.tot = matrix(unlist(temp.tot), nrow=length(names(temp)), ncol=100, byrow=FALSE)
temp.tot = as.data.frame(t(temp.tot))
names(temp.tot) = names(temp)
temp = temp.tot


mod1r32p64_TNR = rbind(c(mean(temp$GUO.TNR), mean(temp$SUREtuned.TNR), mean(temp$SUREtuned.MN.TNR), mean(temp$oracle.xu.TNR), mean(temp$propval.TNR))*100,
	c(sd(temp$GUO.TNR), sd(temp$SUREtuned.TNR), sd(temp$SUREtuned.MN.TNR), sd(temp$oracle.xu.TNR), sd(temp$propval.TNR))*10)
mod1r32p64_TPR = rbind(c(mean(temp$GUO.TPR), mean(temp$SUREtuned.TPR), mean(temp$SUREtuned.MN.TPR), mean(temp$oracle.xu.TPR), mean(temp$propval.TPR))*100,
	c(sd(temp$GUO.TPR), sd(temp$SUREtuned.TPR), sd(temp$SUREtuned.MN.TPR), sd(temp$oracle.xu.TPR), sd(temp$propval.TPR))*10)
vert_mod1r32p64_VS = collateTPR_TNR(mod1r32p64_TNR, mod1r32p64_TPR)

oracle = c(oracle, mean(temp$oracle.mc))
MNLDA = c(MNLDA, mean(temp$MNlda.mc))
GUO = c(GUO, mean(temp$GUO.mc))
SURE = c(SURE, mean(temp$SUREtuned.mc))
propval = c(propval, mean(temp$propval.mc))
SUREMN = c(SUREMN, mean(temp$SUREtuned.MN.mc))
XU = c(XU, mean(temp$oracle.xu.mc))
OrMean = c(OrMean, mean(temp$oracle.propval.mc))


# ---------------------------------
temp.tot = list(NA)
for(k in 1:100){
	filename = paste("Model4_r32p126_", k, ".RDS", sep="")
	temp = readRDS(filename)
	temp.tot[[k]] = temp
}

temp.tot = matrix(unlist(temp.tot), nrow=length(names(temp)), ncol=100, byrow=FALSE)
temp.tot = as.data.frame(t(temp.tot))
names(temp.tot) = names(temp)
temp = temp.tot


mod1r32p126_TNR = rbind(c(mean(temp$GUO.TNR), mean(temp$SUREtuned.TNR), mean(temp$SUREtuned.MN.TNR), mean(temp$oracle.xu.TNR), mean(temp$propval.TNR))*100,
	c(sd(temp$GUO.TNR), sd(temp$SUREtuned.TNR), sd(temp$SUREtuned.MN.TNR), sd(temp$oracle.xu.TNR), sd(temp$propval.TNR))*10)
mod1r32p126_TPR = rbind(c(mean(temp$GUO.TPR), mean(temp$SUREtuned.TPR), mean(temp$SUREtuned.MN.TPR), mean(temp$oracle.xu.TPR), mean(temp$propval.TPR))*100,
	c(sd(temp$GUO.TPR), sd(temp$SUREtuned.TPR), sd(temp$SUREtuned.MN.TPR), sd(temp$oracle.xu.TPR), sd(temp$propval.TPR))*10)
vert_mod1r32p126_VS = collateTPR_TNR(mod1r32p126_TNR, mod1r32p126_TPR)

oracle = c(oracle, mean(temp$oracle.mc))
MNLDA = c(MNLDA, mean(temp$MNlda.mc))
GUO = c(GUO, mean(temp$GUO.mc))
SURE = c(SURE, mean(temp$SUREtuned.mc))
propval = c(propval, mean(temp$propval.mc))
SUREMN = c(SUREMN, mean(temp$SUREtuned.MN.mc))
XU = c(XU, mean(temp$oracle.xu.mc))
OrMean = c(OrMean, mean(temp$oracle.propval.mc))


dev.new(width=4, height=3.5)
par(xpd=T, mar=c(4.1,2.1,2.1,1.1))
plot(c(1, 2, 3, 4, 5), oracle, ylab = "", col="black", xlab=expression("(r,c)"),  type="b", lty=1, pch=8, ylim=c(0, .41), axes=FALSE)
axis(1, at=c(1, 2, 3, 4, 5), labels=c("(32,8)", "(32,16)", "(32,32)", "(32,64)", "(32, 126)"))
axis(2, at=seq(0, .40, by=.1))
lines(c(1, 2, 3, 4, 5), MNLDA, lty=1, pch=16, type="b")
lines(c(1, 2, 3, 4, 5), GUO, lty=3, pch=3,  type="b")
lines(c(1, 2, 3, 4, 5), SURE, lty=3, pch = 4, type="b")
lines(c(1, 2, 3, 4, 5), SUREMN, lty=3, pch=5, type="b")
lines(c(1, 2, 3, 4, 5), XU, lty=5, pch=2, type="b", col="darkgray")
lines(c(1, 2, 3, 4, 5), OrMean, lty=5, pch=3, type="b", col="darkgray")
lines(c(1, 2, 3, 4, 5), propval, lty=1, pch=15,type="b", col="black")

legend(locator(1), cex=.75, legend=c("Bayes", "MN", "Guo", "vec-SURE", "MN-SURE", "PMN", 
expression(paste("Xu(", Sigma,")")), expression(paste("PMN(", M,")"))), 
lty = c(1, 1, 3, 3, 3, 1, 5,5), pch = c(8, 16, 3, 4, 5, 15, 2, 3), 
col=c("black", "black", "black", "black", "black", "black", "grey", "grey"), ncol=2, box.lwd = 0,box.col = "white",bg = "white")


# -----------------------------------------------
# Grand tables for Model 1 
# -----------------------------------------------

table.out = xtable(cbind(vert_mod1r8p8_VS, vert_mod1r16p16_VS, vert_mod1r32p32_VS, vert_mod1r64p64_VS, vert_mod1r32p8_VS, vert_mod1r32p16_VS, vert_mod1r32p64_VS, vert_mod1r32p126_VS))

print(table.out, file="Model4_VS.txt")
