# ---- Convert Baranzini spreadsheet to .csv 
dat = read.csv("Dataset_S1.csv", header=T)

# ------ imputation performed under v2.25 of mice
require(devtools)
install_version("mice", version = "2.25", repos = "http://cran.us.r-project.org")
library(mice)

# ------ 
# length(unique(dat$Patient.code))
X = list(NA)
class = NULL
for(k in 1:length(unique(dat$Patient.code))){
	X[[k]] = dat[which(dat$Patient.code == unique(dat$Patient.code)[k]), ]
	class[k] = unique(dat$Responder[dat$Patient.code == unique(dat$Patient.code)[k]])
}

Xdats = list(NA)
for(j in 1:53){
	Xdats[[j]] = X[[j]][,-c(1:2, 4:6)]
}

dat = array(0, dim=c(7, 78, 53))
for(j in 1:53){

	if(any(Xdats[[j]]$Time.point == "t0")){
		dat[1,,j] = c(j, 0,as.matrix(Xdats[[j]][which(Xdats[[j]]$Time.point=="t0"),-1]))
	} else {
		dat[1,,j] = c(j,0,rep(NA, 76))
	}

	if(any(Xdats[[j]]$Time.point == "t3")){
		dat[2,,j] = c(j,3,as.matrix(Xdats[[j]][which(Xdats[[j]]$Time.point=="t3"),-1]))
	} else {
		dat[2,,j] = c(j,3,rep(NA, 76))
	}

	if(any(Xdats[[j]]$Time.point == "t6")){
		dat[3,,j] = c(j,6,as.matrix(Xdats[[j]][which(Xdats[[j]]$Time.point=="t6"),-1]))
	} else {
		dat[3,,j] = c(j,6,rep(NA, 76))
	}

	if(any(Xdats[[j]]$Time.point == "t9")){
		dat[4,,j] = c(j,9,as.matrix(Xdats[[j]][which(Xdats[[j]]$Time.point=="t9"),-1]))
	} else {
		dat[4,,j] = c(j,9,rep(NA, 76))
	}

	if(any(Xdats[[j]]$Time.point == "t12")){
		dat[5,,j] = c(j,12,as.matrix(Xdats[[j]][which(Xdats[[j]]$Time.point=="t12"),-1]))
	} else {
		dat[5,,j] = c(j,12,rep(NA, 76))
	}

	if(any(Xdats[[j]]$Time.point == "t18")){
		dat[6,,j] = c(j,18,as.matrix(Xdats[[j]][which(Xdats[[j]]$Time.point=="t18"),-1]))
	} else {
		dat[6,,j] = c(j,18,rep(NA, 76))
	}

	if(any(Xdats[[j]]$Time.point == "t24")){
		dat[7,,j] = c(j,24,as.matrix(Xdats[[j]][which(Xdats[[j]]$Time.point=="t24"),-1]))
	} else {
		dat[7,,j] = NA
	}

}

numDat = NULL
for(k in 1:53){
	numDat[[k]] = matrix(0, nrow=6, ncol=78)
	for(j in 1:6){
		for(h in 1:78){
			numDat[[k]][j,h] = as.numeric(dat[j,h,k])
		}
	}
}

# --- predictive mean matching using mice
e = do.call(rbind, numDat)
out = mice(e, maxit=0)
pred = out$pred
imp = mice(e, meth=c("","",rep("pmm",76)), pred=pred, maxit=1, ridge=.01, seed=1)
full = complete(imp, 1)

# -- add 0.1 and take log of imputed raw expression
gene.dat = log(full[,3:78] + .1)
numDat = array(0, dim=c(6, 76, 53))

# --- convert to array for analyses
for(kk in 1:53){
	numDat[,,kk] = as.matrix(gene.dat[(6*(kk-1) + 1):(6*kk), ])
}

# --- extract gene-names + save
dat = read.csv("Dataset_S1.csv", header=T)
dat_full = list("X" = numDat, "genes" = colnames(dat[,-c(1:6)]), "class" = class)
saveRDS(dat_full, "IFNBdat_Imp.RDS")



